#ifndef ERROR_H
#define ERROR_H

#define STATIC 100

#define ALREADYDECLARED   STATIC+ 0, "Formal parameter already declared"
#define ALREADYLOCAL      STATIC+ 1, "Variable already declared as `local'"
#define BADIDENTIFIER     STATIC+ 2, "Identifier can not be declared as %s"
#define BADRANGE          STATIC+ 3, "Ranges must be constructed from single letter identifiers"
#define INVALIDLINE       STATIC+ 4, "Missing line number at the beginning of text line %d"
#define INVALIDUOPERAND   STATIC+ 5, "Invalid unary operand"
#define INVALIDOPERAND    STATIC+ 6, "Invalid binary operand"
#define MISSINGAS         STATIC+ 7, "Missing `as'"
#define MISSINGCOLON      STATIC+ 8, "Missing colon `:'"
#define MISSINGCOMMA      STATIC+ 9, "Missing comma `,'"
#define MISSINGCP         STATIC+10, "Missing right parenthesis `)'"
#define MISSINGDATAINPUT  STATIC+11, "Missing `data' input"
#define MISSINGEQ         STATIC+12, "Missing equal sign `='"
#define MISSINGEXPR       STATIC+13, "Missing %s expression"
#define MISSINGFILE       STATIC+14, "Missing `file'"
#define MISSINGGOTOSUB    STATIC+15, "Missing `goto' or `gosub'"
#define MISSINGIDENTIFIER STATIC+16, "Missing %s identifier"
#define MISSINGINCREMENT  STATIC+17, "Missing line increment"
#define MISSINGLEN        STATIC+18, "Missing `len'"
#define MISSINGLINENUMBER STATIC+19, "Missing line number"
#define MISSINGMODE       STATIC+20, "Missing mode"
#define MISSINGOP         STATIC+21, "Missing left parenthesis `('"
#define MISSINGSEMICOLON  STATIC+22, "Missing semicolon `;'"
#define MISSINGMULT       STATIC+23, "Missing star `*'"
#define MISSINGSTATEMENT  STATIC+24, "Missing statement"
#define MISSINGTHEN       STATIC+25, "Missing `then'"
#define MISSINGTO         STATIC+26, "Missing `to'"
#define NESTEDDEFINITION  STATIC+27, "Nested definition"
#define NOPROGRAM         STATIC+28, "No program"
#define NOSUCHDATALINE    STATIC+29, "No such `data' line"
#define NOSUCHLINE        STATIC+30, "No such line"
#define REDECLARATION     STATIC+31, "Redeclaration as different kind of symbol"
#define STRAYCASE         STATIC+32, "`case' without `select case'"
#define STRAYDO           STATIC+33, "`do' without `loop'"
#define STRAYDOWHILE      STATIC+34, "`do while' without `loop'"
#define STRAYELSE1        STATIC+35, "`else' without `if'"
#define STRAYELSE2        STATIC+36, "`else' without `end if'"
#define STRAYENDIF        STATIC+37, "`end if' without multiline `if' or `else'"
#define STRAYENDPROC      STATIC+38, "`end proc' without `def proc'"
#define STRAYENDSUB       STATIC+39, "`end sub' without `sub'"
#define STRAYENDSELECT    STATIC+40, "`end select' without `select case'"
#define STRAYENDFN        STATIC+41, "`end function' without `def fn' or `function'"
#define STRAYENDEQ        STATIC+41, "`=' returning from function without `def fn'"
#define STRAYEXITDO       STATIC+42, "`exit do' without `do'"
#define STRAYEXITFOR      STATIC+43, "`exit for' without `for'"
#define STRAYFNEND        STATIC+44, "`fnend' without `def fn'"
#define STRAYFNRETURN     STATIC+44, "`fnreturn' without `def fn'"
#define STRAYFOR          STATIC+44, "`for' without `next'"
#define STRAYIF           STATIC+45, "`if' without `end if'"
#define STRAYLOCAL        STATIC+46, "`local' without `def fn' or `def proc'"
#define STRAYLOOP         STATIC+47, "`loop' without `do'"
#define STRAYLOOPUNTIL    STATIC+48, "`loop until' without `do'"
#define STRAYNEXT         STATIC+49, "`next' without `for'"
#define STRAYREPEAT       STATIC+50, "`repeat' without `until'"
#define STRAYSELECTCASE   STATIC+51, "`select case' without `end select'"
#define STRAYUNTIL        STATIC+52, "`until' without `repeat'"
#define STRAYWEND         STATIC+53, "`wend' without `while'"
#define STRAYWHILE        STATIC+54, "`while' without `wend'"
#define SYNTAX            STATIC+55, "Syntax"
#define TOOFEW            STATIC+56, "Too few parameters"
#define TOOMANY           STATIC+57, "Too many parameters"
#define TYPEMISMATCH1     STATIC+58, "Type mismatch (has %s, need %s)"
#define TYPEMISMATCH2     STATIC+59, "Type mismatch of argument %d"
#define TYPEMISMATCH3     STATIC+60, "%s of argument %d"
#define TYPEMISMATCH4     STATIC+61, "Type mismatch (need string variable)"
#define TYPEMISMATCH5     STATIC+62, "Type mismatch (need numeric variable)"
#define TYPEMISMATCH6     STATIC+62, "Type mismatch (need numeric value)"
#define UNDECLARED        STATIC+63, "Undeclared function or variable"
#define UNNUMBERED        STATIC+64, "Use `renum' to number program first"
#define UNREACHABLE       STATIC+65, "Line not reachable"
#define VOIDVALUE         STATIC+66, "Procedures do not return values"

#define RUNTIME 200

#define MISSINGINPUTDATA  RUNTIME+0, "Missing input data"
#define MISSINGCHARACTER  RUNTIME+1, "Missing character after underscore `_' in format string"
#define NOTINDIRECTMODE   RUNTIME+2, "Not allowed in interactive mode"
#define NOTINPROGRAMMODE  RUNTIME+3, "Not allowed in program mode"
#define BREAK             RUNTIME+4, "Break"
#define UNDEFINED         RUNTIME+5, "%s is undefined"
#define OUTOFRANGE        RUNTIME+6, "%s is out of range"
#define STRAYRESUME       RUNTIME+7, "`resume' without exception"
#define STRAYRETURN       RUNTIME+8, "`return' without `gosub'"
#define BADCONVERSION     RUNTIME+9, "Bad %s conversion"
#define IOERROR           RUNTIME+10,"Input/Output error (%s)"
#define IOERROR2          RUNTIME+10,"Input/Output error (%s file %s: %s)"
#define ENVIRONFAILED     RUNTIME+11,"Setting environment variable failed (%s)"
#define REDIM             RUNTIME+12,"Trying to redimension existing array"
#define FORKFAILED        RUNTIME+13,"Forking child process failed (%s)"
#define BADMODE           RUNTIME+14,"Invalid mode"
#define ENDOFDATA         RUNTIME+15,"end of `data'"
#define DIMENSION         RUNTIME+16,"Dimension mismatch"
#define NOMATRIX          RUNTIME+17,"Variable dimension must be 2, not %d"
#define SINGULAR          RUNTIME+18,"Singular matrix"

#endif
