#ifndef PROGRAM_H
#define PROGRAM_H

#include "programtypes.h"
#include "token.h"

extern struct Program *Program_new(struct Program *this);
extern void Program_destroy(struct Program *this);
extern void Program_store(struct Program *this, struct Token *line, long int where);
extern int Program_delete(struct Program *this, long int line);
extern void Program_addScope(struct Program *this, struct Scope *scope);
extern struct Pc *Program_goLine(struct Program *this, long int line, struct Pc *pc);
extern int Program_scopeCheck(struct Program *this, struct Pc *pc, struct Pc *fn);
extern struct Pc *Program_dataLine(struct Program *this, long int line, struct Pc *pc);
extern long int Program_lineNumber(struct Program *this, struct Pc *pc);
extern struct Pc *Program_beginning(struct Program *this, struct Pc *pc);
extern struct Pc *Program_end(struct Program *this, struct Pc *pc);
extern struct Pc *Program_nextLine(struct Program *this, struct Pc *pc);
extern int Program_skipEOL(struct Program *this, struct Pc *pc, int dev, int tr);
extern void Program_trace(struct Program *this, struct Pc *pc, int dev, int tr);
extern void Program_PCtoError(struct Program *this, struct Pc *pc, struct Value *v);
extern struct Value *Program_merge(struct Program *this, int dev, struct Value *value);
extern struct Value *Program_list(struct Program *this, int dev, struct Pc *from, struct Pc *to, struct Value *value);
extern void Program_renum(struct Program *this, int first, int inc);
extern void Program_unnum(struct Program *this);

#endif
