#ifndef VAR_H
#define VAR_H

#include "value.h"

struct Var
{
  enum ValueType type;
  unsigned int dim;
  unsigned int *geometry;
  struct Value *value;
  unsigned int size;
};

extern struct Var *Var_new(struct Var *this, enum ValueType type, unsigned int dim, const unsigned int *geometry);
extern struct Var *Var_new_scalar(struct Var *this);
extern void Var_destroy(struct Var *this);
extern void Var_retype(struct Var *this, enum ValueType type);
extern struct Value *Var_value(struct Var *this, unsigned int dim, unsigned int idx[], struct Value *value);
extern void Var_clear(struct Var *this);
extern struct Value *Var_mat_assign(struct Var *this, struct Var *x, struct Value *err, int work);
extern struct Value *Var_mat_addsub(struct Var *this, struct Var *x, struct Var *y, int add, struct Value *err, int work);
extern struct Value *Var_mat_mult(struct Var *this, struct Var *x, struct Var *y, struct Value *err, int work);
extern struct Value *Var_mat_scalarMult(struct Var *this, struct Value *factor, struct Var *x, int work);
extern void Var_mat_transpose(struct Var *this, struct Var *x);
extern struct Value *Var_mat_invert(struct Var *this, struct Var *x, struct Value *err);

#endif
